
CompilerIf Defined(DEVICE_OBJECT, #PB_Structure)=0
  XIncludeFile "DDK.pbi"
CompilerEndIf

Declare DriverEntry(*DriverObject, *RegistryPath)

!public PureBasicStart
!section '.code' code readable executable align 8
!PureBasicStart:
*A=@DriverEntry()
!jmp [p_A]

Import "ntoskrnl.lib"
  IoCompleteRequest(*IRP, PriorityBoost)
  RtlInitUnicodeString(*UString, *String)
  IoCreateDevice(*DriverObject, DeviceExtensionSize, *UDeviceName, DeviceType, DeviceCharacteristics, Exclusive, *DeviceObject)
  IoDeleteDevice(*DeviceObject)
  IoCreateSymbolicLink(*SymbolicLinkName, *DeviceName)
  IoDeleteSymbolicLink(*SymbolicLinkName)
EndImport

; ImportC "ntoskrnl.lib"
; 	DbgPrint(a.s)
; EndImport


#IOCTL_READ_PORT_UCHAR	 = $200 
#IOCTL_WRITE_PORT_UCHAR	 = $400


Procedure.b InPort(Port.u)
 Protected Result.b=0
 EnableASM
 MOV DX, Port
 IN  al,DX
 MOV Result, al
 DisableASM
ProcedureReturn Result
EndProcedure

Procedure OutPort(Port.u, Byte.a)
 EnableASM
 MOV al, Byte
 MOV DX, Port
 OUT DX, al
 DisableASM
EndProcedure

Procedure DeviceIoControl(*DeviceObject.DEVICE_OBJECT, *pIrp._IRP)
  Protected ntStatus, *Point
  
  inBuffersize = PeekL(*pIrp\Tail\Overlay\CurrentStackLocation+8)
  outBuffersize = PeekL(*pIrp\Tail\Overlay\CurrentStackLocation+4)
  CtrlBuff   = PeekL(*pIrp\SystemBuffer)
  address = CtrlBuff & $FFFF
  Infa    = (CtrlBuff>>16)&255
  Code = PeekL(*pIrp\Tail\Overlay\CurrentStackLocation+12)
  Select Code
    Case #IOCTL_READ_PORT_UCHAR
      InByte.b=InPort(address)
      PokeB(*pIrp\SystemBuffer, InByte)
      *pIrp\IoStatus\Information = 1
      
    Case #IOCTL_WRITE_PORT_UCHAR
      OutPort(address, Infa)
      *pIrp\IoStatus\Information = 10
      
    Default
      ntStatus = #STATUS_SUCCESS
      *pIrp\IoStatus\Information = 0
  EndSelect
  
  ntStatus = #STATUS_SUCCESS
  
  *pIrp\IoStatus\Status = ntStatus
  IoCompleteRequest(*pIrp, #IO_NO_INCREMENT)
  
  ProcedureReturn ntStatus
EndProcedure

Procedure CreateDispatch(*DeviceObject.DEVICE_OBJECT, *pIrp._IRP)
  *pIrp\IoStatus\Information = 0
  *pIrp\IoStatus\Status = #STATUS_SUCCESS
  IoCompleteRequest(*pIrp, #IO_NO_INCREMENT)
  ;Irp
  ProcedureReturn #STATUS_SUCCESS
EndProcedure

Procedure UnloadDriver(*DriverObject.DRIVER_OBJECT)
  Protected uniDOSString.UNICODE_STRING
  RtlInitUnicodeString(@uniDOSString, ?DosDevices)
  IoDeleteSymbolicLink (@uniDOSString)
  IoDeleteDevice(*DriverObject\DeviceObject)
EndProcedure


Procedure DriverEntry(*DriverObject.DRIVER_OBJECT, *RegistryPath.UNICODE_STRING)
  Protected deviceObject.DEVICE_OBJECT
  Protected uniNameString.UNICODE_STRING
  Protected uniDOSString.UNICODE_STRING
  RtlInitUnicodeString(@uniNameString, ?Device)
  RtlInitUnicodeString(@uniDOSString, ?DosDevices)
  status = IoCreateDevice(*DriverObject, 0, @uniNameString, #FILE_DEVICE_UNKNOWN, 0, #False, @deviceObject)
  If status <> #STATUS_SUCCESS
    ProcedureReturn status
  EndIf
  
  status = IoCreateSymbolicLink(@uniDOSString, @uniNameString)
  If status <> #STATUS_SUCCESS
    ProcedureReturn status
  EndIf
  
	*DriverObject\DriverUnload = @UnloadDriver()
	
	*DriverObject\MajorFunction[#IRP_MJ_CREATE] = @CreateDispatch()
	*DriverObject\MajorFunction[#IRP_MJ_DEVICE_CONTROL] = @DeviceIoControl()
	
	ProcedureReturn #STATUS_SUCCESS
EndProcedure

!extrn PB_PeekL
!extrn PB_PokeL
!extrn PB_PeekB
!extrn PB_PokeB
;!extrn _DbgPrint
!extrn _IoCompleteRequest@8
!extrn _RtlInitUnicodeString@8
!extrn _IoCreateDevice@28
!extrn _IoDeleteDevice@4
!extrn _IoCreateSymbolicLink@8
!extrn _IoDeleteSymbolicLink@4



; 
DataSection
  
  Device:
  !du '\Device\pbdriverio', 0, 0
  
  DosDevices:
  ;!du '\DosDevices\pbdriverio', 0, 0
  
  Data.a $5C, $00, $44, $00, $6F, $00, $73, $00, $44, $00
  Data.a $65, $00, $76, $00, $69, $00, $63, $00, $65, $00
  Data.a $73, $00, $5C, $00, $70, $00, $62, $00, $64, $00
  Data.a $72, $00, $69, $00, $76, $00, $65, $00, $72, $00
  Data.a $69, $00, $6F, $00, $00, 0

EndDataSection
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 24
; FirstLine = 12
; Folding = --
; Executable = pbdriverio.sys
; LinkerOptions = commandline.txt
; CompileSourceDirectory
; EnablePurifier
; EnableBuildCount = 118
; EnableExeConstant
; IncludeVersionInfo
; VersionField0 = 1,2,0,0
; VersionField1 = 1,2,0,0
; VersionField2 = PureBasic Compiler
; VersionField3 = pbdriverio
; VersionField4 = 1.2
; VersionField5 = 1.2
; VersionField6 =        .
; VersionField7 = pbdriverio
; VersionField8 = pbdriverio.sys
; VersionField13 = pure-basic@yandex.ru
; VersionField14 = http://www.pure-basic.narod.ru/
; VersionField15 = VOS_NT
; VersionField16 = VFT_DRV
; VersionField17 = 0419 Russian